unit Demo1;

{Simple software security implementation using CyberBolt.}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Mask, StdCtrls, CyberBlt, HyperStr;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    //security key manipulation routines
    procedure SaveKey;
    procedure ReadKey;
    procedure KillKey;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Key  : AnsiString = '';   //our security key
  sReg, sFile : AnsiString;
const
  Serial = $EFD;

implementation

{$R *.DFM}

procedure TForm1.SaveKey;
  {Save currently active key to disk and registry}
var
  hFile : file;         {file handle}
  hReg  : THandle;      {registry handle}
begin
  //save to file
  AssignFile(hFile, sFile);
  Rewrite(hFile, 1);
  BlockWrite(hFile, Key[1], Length(Key));
  CloseFile(hFile);
  //save to registry
  if RegCreateKey(HKEY_LOCAL_MACHINE,PChar(sReg),hReg)=ERROR_SUCCESS then begin
    RegSetValue(hReg,nil,REG_SZ,PChar(Key),Length(Key));
    RegFlushKey(hReg);
    RegCloseKey(hReg);
  end;
end;


procedure TForm1.ReadKey;
  {Read currently active key from disk and registry.  Kill all keys on error.}
var
  hFile : file;         {file handle}
  hReg  : THandle;      {registry handle}
  I     : Integer;
  Tmp   : AnsiString;
begin
  if FileExists(sFile) then begin
    //read from file
    AssignFile(hFile, sFile);
    Reset(hFile, 1);
    SetLength(Tmp,32);
    BlockRead(hFile, Tmp[1], 32);
    Truncate(hFile); //update file date
    CloseFile(hFile);
    //read from registry
    if RegOpenKey(HKEY_LOCAL_MACHINE,PChar(sReg),hReg)=ERROR_SUCCESS then begin
      Setlength(Key,33);
      I:=Length(Key);
      if RegQueryValue(hReg,nil,PChar(Key),I)=ERROR_SUCCESS then
         SetLength(Key,StrLen(PChar(Key)));
      RegCloseKey(hReg);
      if Key<>Tmp then KillKey;  //kill keys on mis-match
    end else KillKey;
  end else KillKey;
end;


procedure TForm1.KillKey;
  {Delete currently active key from disk file, registry and memory}
begin
  //kill the disk file
  DeleteFile(sFile);
  //kill the registry key
  RegDeleteKey(HKEY_LOCAL_MACHINE,PChar(sReg));
  //kill the key in memory
  Key := ' ';
end;


procedure TForm1.Button1Click(Sender: TObject);
  //Simulate a "protected" feature.
var
  Tmp: AnsiString;
  OK: Boolean;
  I: Integer;
begin
  if Key<>' ' then ReadKey;
  Tmp := Key;
  I := VerifyKey(Tmp,Serial);
  if I = 0 then begin  //no or invalid key
    Key := ' ';
    OK := InputQuery('Key Required', 'Your system code is '+Tmp, Key);
    if OK then begin
      I := VerifyKey(Key,Serial);
      if I > 0 then begin
        SaveKey;
        ShowMessage('Congratulations! This feature has been unlocked for '+IntToStr(I)+' days');
      end else begin
        ShowMessage('Sorry! Your key was rejected.');
        Key := ' ';
      end;
    end;
  end else begin //valid key
    if Key<>Tmp then begin  //delayed adaptation to a key change
      Randomize;
      if Random(100)>90 then begin
        Key:=Tmp;
        SaveKey;
      end;
    end;
    ShowMessage('Use of this feature will expire in '+IntToStr(I)+' days.');
  end;
end;


procedure TForm1.Button2Click(Sender: TObject);
  //Create a new unlock key
var
  C,D:AnsiString;
  I:Integer;
const
  ErrMsg : AnsiString = 'Sorry! Your input was invalid.';
begin
  if InputQuery('Create Key', 'Enter system code, lifetime in days (-1 = max.)', C) then begin
    I:=ScanC(C,',',1);
    if I>0 then begin
      D:=CStr(C,I+1,Length(C)); //days to expire in D
      SetLength(C,I-1);         //system code in C
      I:=StrToInt(D);           //numeric days to expire in I
      if CreateKey(C,Serial,I) then
        ShowMessage('Your key is '+C)
      else I:=0;
    end;
    if I=0 then ShowMessage(ErrMsg);
  end;
end;


procedure TForm1.Button3Click(Sender: TObject);
  //clear the current key (in memory only)
begin
  Key:=' ';
  ShowMessage('The demo has been reset. The "protected" feature now requires a key.');
end;


procedure TForm1.FormActivate(Sender: TObject);
var
  I:Integer;
begin
  if SelfCheck=False then Application.Terminate;
  Application.HintPause:=1000;  //increase hint pause
  sReg :='SOFTWARE\EFD\Bolt';   //initialize registry path for "key"
  sFile:=Application.ExeName;   //initialize file path for "key"
  I:=ScanB(sFile,'.',0);
  if I>0 then OverWrite(sFile,'.BLT',I) else sFile:=sFile+'.BLT';
  I:=FileAge(sFile);
  if I>0 then begin             //check for system clock manipulation
    if Now<FileDateToDateTime(I) then begin
      ShowMessage('Please reset the system clock and try again.');
      Application.Terminate;
    end;
  end;
end;

end.

